﻿require 'map'
require 'output'
require 'names'
require 'enemies'
require 'items'
require 'bresenham'

function love.load()

	loadMap()

	width = love.graphics.getWidth() --width of window
	height = love.graphics.getHeight() --height of window

   	moon = {
    	x = 0,
    	y = 150,
    	speed = {x = 20, y = 5},
    	img = love.graphics.newImage("moonbigtest.png"),
    	height = 300,
    	width = 300    	
	}

	creditstext = {y=0,speed=100}

	cloud = {
		{image = love.graphics.newImage("cloud.png"), width = love.graphics.getWidth(image), x=0, y=love.math.random(20,300), speed=70},
		{image = love.graphics.newImage("cloud.png"), width = love.graphics.getWidth(image), x=0, y=love.math.random(20,300), speed=50},
		{image = love.graphics.newImage("cloud.png"), width = love.graphics.getWidth(image), x=0, y=love.math.random(20,300), speed=100},
		{image = love.graphics.newImage("cloud.png"), width = love.graphics.getWidth(image), x=0, y=love.math.random(20,300), speed=20}
}


	introfont = love.graphics.newFont("yoster.ttf",90)
	love.graphics.setFont(introfont)

    	state = "menu"

	output.intro()
	namegeneration()


	playertest = {}
	playertest.name = string.upper(firstname).." "..string.upper(lastname)
	playertest.hp = 100
	playertest.dungeonlevel = 1
	playertest.tilecount = 0
	playertest.experience = 0
	playertest.money = 0
	playertest.alive = true
	playertest.basedmg = 20
	playertest.critchance = 10
	playertest.armorpenetration = 10
	playertest.weapondmg = 0
	playertest.weaponcritchance = 0
	playertest.walls = 4

	wallmode = false

	tilesheet = love.graphics.newImage( "Alloy_curses_12x12.png" )

	local tileW, tileH = 12,12
	local tilesetW, tilesetH = tilesheet:getWidth(), tilesheet:getHeight()

	playerquad = love.graphics.newQuad(0,  48, tileW, tileH, tilesetW, tilesetH)

	enemyquad = love.graphics.newQuad(12,  0, tileW, tileH, tilesetW, tilesetH)

	playertilex = 25
	playertiley = 15

	dx = 0
	dy = 0

	output.intro()

	a= math.random(255)
	b=math.random(255)
	c=math.random(255)

	messages = {}

	messageTable = {}
	messageTable.triggered = false
	messageTable.delta = 0
	--messageTable.slideSpeed = 1.0 -- seconds
	screenWidth = 800

	output.introgame()

	wallamount = 4

    --output.sound()


end


function love.draw()

	if state == "game" then

		output.game()
		
		output.stats()
		
		output.player()

		output.enemies()

		healthcheck()

		if playertest.alive == true then

			output.messages()
		end

		output.playerportraits()

    	elseif state == "menu" then
            output.intro()
            output.mainmenu()
	elseif state == "credits" then
		output.credits()
	elseif state == "story" then
		output.story()

	elseif state == "gameover" then
		output.gameover()
    
    elseif state == "gamewon" then
        output.gamewon()
    end

end


function love.update(dt)

	require("lurker").update()

	if state == "game" then

		--output.sanitylevel(dt)

		--if timercount == true then

			output.timer(dt)
		--end
		
    	elseif state == "menu" then
		output.intro_movement(dt)
	elseif state == "credits" then
		output.credits_movement(dt)
	elseif state == "story" then
		output.credits_movement(dt)
	end

end

function healthcheck()

	if playertest.hp <= 0 then
		playertest.alive = false
		--output.gameover()
	end

	if playertest.alive == false then
		output.gameover()
	end

end


function love.keypressed(key,isrepeat) 

	if state == "game" then	


		if key == "up" and playertest.alive == true then

			if playercheck(0,-1) and doorcheck(0,-1) then

				checkitems(0,-1)
				
				--moveEnemy()
				--enemyattack()

				--playertest.y = playertest.y - tile
				playertiley = playertiley - 1
				playertest.tilecount = playertest.tilecount + 1
				moveEnemy()
				--checkitems(dx,dy)
			
			end

			--moveEnemy()
			enemyattack()

			enemysideattack = true


		
 		elseif key == "down" and playertest.alive == true then

			if playercheck(0,1) and doorcheck(0,1) then

				checkitems(0,1)
				
				--moveEnemy()
				--enemyattack()

				playertiley = playertiley + 1
				playertest.tilecount = playertest.tilecount + 1
				moveEnemy()

			end
			
			--moveEnemy()
			enemyattack()

			enemysideattack = true
    			--if testMap(0,1) then
        		--player.grid_y = player.grid_y + 32
			--test:move(0,1)
			--camera:setPosition(0, player.grid_y - 322)
        		--end
    		elseif key == "left" and playertest.alive == true then
			
			if playercheck(-1,0) and doorcheck(-1,0) then

				checkitems(-1,0)
				
				--moveEnemy()

				--enemyattack()

				playertilex = playertilex - 1
				playertest.tilecount = playertest.tilecount + 1
				moveEnemy()


			end

			--moveEnemy()
			enemyattack()

			enemysideattack = true
				--if testMap(-1,0) then
            		--player.grid_x = player.grid_x - 32
	    		--camera:setPosition(player.grid_x - 32,0)
        		--end
			--test:move(-1,0)
    		elseif key == "right" and playertest.alive == true then
			
			if playercheck(1,0) and doorcheck(1,0) then

				checkitems(1,0)

				--moveEnemy()

				--enemyattack()

				playertilex = playertilex + 1
				playertest.tilecount = playertest.tilecount + 1
				moveEnemy()

			end

			--moveEnemy()
			enemyattack()

			enemysideattack = true
    			--if testMap(1,0) then
        		--player.grid_x = player.grid_x + 32
			--test:move(1,0)
			--camera:setPosition(player.grid_x + 32,0)
        		--end
		elseif key == 'q' then
			--love.event.quit()
			state = "menu"

		--elseif key == "y" then

			--table.insert(enemies,createEnemy())
			--output.addMessage("Enemy added at "..enemy.x.." "..enemy.y)
		elseif key == "," then

			if playertest.alive == true then

				if isitfloor() then

					playertileon()
					removeitem()
				end
			end
		--elseif key == string.char(62) then DOESNT WORK
		--elseif key == " " then

			--changemap()

		--elseif key == "f" then

			--dungeonlevel = 50

			--output.timer()

		--elseif key == "o" then
			--playertest.alive = false

		--elseif key == 'p' then
			--generateitems()
			--table.insert(items,createitem())
		elseif key == "n" then
				output.addMessage("Press [w],[d],[s],[a] to add a wall.")
				wallmode = true
		elseif key == "d" and wallmode == true then
			walladd(1,0)
		elseif key == "s" and wallmode == true then
			walladd(0,1)
		elseif key == "a" and wallmode == true then
			walladd(-1,0)
		elseif key == "w" and wallmode == true then
			walladd(0,-1)
		--elseif key == "t" then
			--fieldofview()
        --elseif key == 'm' then
            --debugchangemap()
		end

	elseif state == "menu" then

    		if key == "return" then
    			state = "game"
   		--elseif key == "c" then
    			--state = "credits"   	
    		elseif key == "q" then
    			love.event.quit()   	
    		--elseif key == "s" then
    			--state = "story" 	
    		end
	elseif state == "gameover" then

		if key == "q" then
			love.event.quit()
		end
	
    elseif state == "gamewon" then

        if key == "q" then
            love.event.quit()
        end
    end

end


